unit U_Mine3D;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids;

type
  TForm1 = class(TForm)
    Button1: TButton;
    GroupBox1: TGroupBox;
    EbeneM1: TStringGrid;
    EbeneWahl: TComboBox;
    Ebene1: TStringGrid;
    Ebene0: TStringGrid;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit4: TEdit;
    Label4: TLabel;
    l_m1: TLabel;
    l_0: TLabel;
    l_1: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label5: TLabel;
    Edit5: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure EbeneWahlChange(Sender: TObject);
    procedure Ebene0SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure setvalues;
    procedure changeEbene;
    procedure createnew;
    procedure selectfield(x1,y1,z1:Integer);
    procedure Visualize;
    procedure clearfield;
    function checkall:boolean;
  end;

var
  Form1: TForm1;
  x,y,z,bombs: Integer;
  Ebene:Integer;
  Game:array[1..10,1..10,1..10] of Integer;
  UserGame:array[1..10,1..10,1..10] of Integer;
  UserBomb:Integer=0;
  run:boolean=false;

implementation

{$R *.dfm}

//######################################
//#######BEGIN OWN PROCEDURES###########
//######################################

procedure TForm1.setvalues;
var i,j:Integer;
begin
  EbeneM1.ColCount:=x+1;
  EbeneM1.RowCount:=y+1;
  Ebene0.ColCount:=x+1;
  Ebene0.RowCount:=y+1;
  Ebene1.ColCount:=x+1;
  Ebene1.RowCount:=y+1;

  EbeneWahl.Clear;

  for i:=1 to 11 do
    begin
      EbeneM1.Cells[i,0]:=Chr(64+i);
      EbeneM1.Cells[0,i]:=IntToStr(i);
      Ebene0.Cells[i,0]:=Chr(64+i);
      Ebene0.Cells[0,i]:=IntToStr(i);
      Ebene1.Cells[i,0]:=Chr(64+i);
      Ebene1.Cells[0,i]:=IntToStr(i);
      for j:=1 to 11 do
        begin
          EbeneM1.Cells[i,j]:='';
          Ebene0.Cells[i,j]:='';
          Ebene1.Cells[i,j]:='';
        end;
    end;

  for i:=1 to z do
    EbeneWahl.AddItem('Ebene '+IntToStr(i),self);

  EbeneWahl.ItemIndex:=(z DIV 2);

  Ebene:=(z DIV 2)+1;

  UserBomb:=0;

  Edit5.Text:=IntToStr(Userbomb);
end;



procedure TForm1.changeEbene;
begin

  if Ebene+1 > z then Ebene1.Visible:=false else Ebene1.Visible:=true;
  if Ebene+1 > z then l_1.Visible:=false else l_1.Visible:=true;
  if Ebene-1 < 1 then EbeneM1.Visible:=false else EbeneM1.Visible:=true;
  if Ebene-1 < 1 then l_m1.Visible:=false else l_m1.Visible:=true;

  l_m1.Caption:='Ebene '+IntToStr(Ebene-1);
  l_0.Caption:='Ebene '+IntToStr(Ebene);
  l_1.Caption:='Ebene '+IntToStr(Ebene+1);
end;

procedure TForm1.createnew;
var i,j,k,c:integer;
l1,l2,m1,m2,n1,n2:integer;
o,p,q:Integer;
begin
  Randomize;

//RESET
  for i:=1 to x do
    for j:=1 to y do
      for k:=1 to z do
        begin
          UserGame[i,j,k]:=-1;
          Game[i,j,k]:=-1;
        end;

//BOMBEN einbauen
  for i:=1 to bombs do
    Game[Random(x-1)+1,Random(y-1)+1,Random(z-1)+1]:=666;

//zaehlen
  for i:=1 to x do
    for j:=1 to y do
      for k:=1 to z do
        begin
          if Game[i,j,k]<>666 then // wenn keine bombe, zaehle bomben
            begin
              c:=0;
              if i-1>=1 then l1:=-1 else l1:=0;
              if i+1<=x then l2:=1 else l2:=0;
              if j-1>=1 then m1:=-1 else m1:=0;
              if j+1<=y then m2:=1 else m2:=0;
              if k-1>=1 then n1:=-1 else n1:=0;
              if k+1<=z then n2:=1 else n2:=0;
              for o:=l1 to l2 do
                for p:=m1 to m2 do
                  for q:=n1 to n2 do
                    if Game[i+o,j+p,k+q]=666 then
                      c:=c+1;
              Game[i,j,k]:=c;
            end;
        end;
end;

procedure TForm1.selectfield(x1,y1,z1:Integer);
var
i,j,k:Integer;
l1,l2,m1,m2,n1,n2:integer;
begin
  if Game[x1,y1,z1]=666 then
    begin
      UserGame[x1,y1,z1]:=666;
      run:=false;
    end
  else
    begin
      UserGame[x1,y1,z1]:=Game[x1,y1,z1];
      if Game[x1,y1,z1]=0 then
        begin
          if x1-1>=1 then l1:=-1 else l1:=0;
          if x1+1<=x then l2:=1 else l2:=0;
          if y1-1>=1 then m1:=-1 else m1:=0;
          if y1+1<=y then m2:=1 else m2:=0;
          if z1-1>=1 then n1:=-1 else n1:=0;
          if z1+1<=z then n2:=1 else n2:=0;
          for i:=l1 to l2 do
            for j:=m1 to m2 do
              for k:=n1 to n2 do
                if UserGame[x1+i,y1+j,z1+k]=-1 then
                  selectfield(x1+i,y1+j,z1+k);
        end;
    end;
end;

procedure TForm1.Visualize;
var i,j,k:Integer;
begin
  for i:=1 to x do
    for j:=1 to y do
      begin
        if UserGame[i,j,Ebene]=-1 then Ebene0.Cells[i,j]:=''
         else if UserGame[i,j,Ebene]=666 then Ebene0.Cells[i,j]:='X'
         else if UserGame[i,j,Ebene]=999 then Ebene0.Cells[i,j]:='#'
         else Ebene0.Cells[i,j]:=IntToStr(UserGame[i,j,Ebene]);

        if Ebene+1 <= z then
         begin
         if UserGame[i,j,Ebene+1]=-1 then Ebene1.Cells[i,j]:=''
          else if UserGame[i,j,Ebene+1]=666 then Ebene1.Cells[i,j]:='X'
          else if UserGame[i,j,Ebene+1]=999 then Ebene1.Cells[i,j]:='#'
          else Ebene1.Cells[i,j]:=IntToStr(UserGame[i,j,Ebene+1]);
         end;

        if Ebene-1 >= 1 then
         begin
         if UserGame[i,j,Ebene-1]=-1 then EbeneM1.Cells[i,j]:=''
          else if UserGame[i,j,Ebene-1]=666 then EbeneM1.Cells[i,j]:='X'
          else if UserGame[i,j,Ebene-1]=999 then EbeneM1.Cells[i,j]:='#'
          else EbeneM1.Cells[i,j]:=IntToStr(UserGame[i,j,Ebene-1]);
         end;
      end;
end;

procedure TForm1.clearfield;
begin
 GroupBox1.Visible:=false;
end;

function TForm1.checkall:boolean;
var i,j,k:Integer;
begin
  Result:=true;
  for i:=1 to x do
    for j:=1 to y do
      for k:=1 to z do
        if UserGame[i,j,k]=-1 then Result:=false;
  if UserBomb <> bombs then Result:=false;
end;

//######################################
//########END OWN PROCEDURES############
//######################################


procedure TForm1.Button1Click(Sender: TObject);
var err:Integer;
begin
  Val(Edit1.Text,x,err);
  Val(Edit2.Text,y,err);
  Val(Edit3.Text,z,err);
  Val(Edit4.Text,bombs,err);

  if (x <= 0) OR (x>10) then begin clearfield; exit; end;
  if (y <= 0) OR (y>10) then begin clearfield; exit; end;
  if (z <= 0) OR (z>10) then begin clearfield; exit; end;
  if (bombs <=0) OR (bombs >=(x*y*z)) then begin clearfield; exit; end;

  run:=true;

  setvalues;

  createnew;

  changeEbene;

  GroupBox1.Visible:=true;
end;

procedure TForm1.EbeneWahlChange(Sender: TObject);
begin
  if run<>true then exit;

  Ebene:=EbeneWahl.ItemIndex+1;

  changeEbene;

  Visualize;
end;

//###########################

procedure TForm1.Ebene0SelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  if run<>true then exit;

  if RadioButton1.Checked then
    begin
      if UserGame[Acol,ARow,Ebene]=-1 then
        selectfield(Acol,ARow,Ebene);
    end
  else if UserGame[Acol,ARow,Ebene]=-1 then
    begin
     UserGame[Acol,ARow,Ebene]:=999;
     UserBomb:=UserBomb+1;
    end
  else if UserGame[Acol,ARow,Ebene]=999 then
    begin
     UserGame[Acol,ARow,Ebene]:=-1;
     UserBomb:=UserBomb-1;
    end;

  Edit5.Text:=IntToStr(Userbomb);

  Visualize;

//GameOver
  if run<>true then
    ShowMessage('BOMBE GameOver');
//WIN
  if checkall then
    begin
      run:=false;
      ShowMessage('You are the Winner');
    end;
end;

end.
